#include <stdio.h>

//---------------------------------------------------------------------------
// Determines the byte-ordering of the current machine (little or big endian)
// by setting an integer value to 1 (so least significant bit is now 1); take
// the address of the int and cast to a byte pointer (treat integer as an
// array of four bytes); check the value of the first byte (must be 0 or 1).
// If the value is 1, then the first byte least significant byte and this
// implies LITTLE endian. If the value is 0, the first byte is the most
// significant byte, BIG endian. Examples:
//      integer 1 on BIG endian: 00000000 00000000 00000000 00000001
//   integer 1 on LITTLE endian: 00000001 00000000 00000000 00000000
//---------------------------------------------------------------------------
int IsLittleEndian()
{
  int x=1;
  return ( ((char*)(&x))[0] );
}

void main()
{
  if (IsLittleEndian()) printf("You are using a LITTLE endian machine!\n");
  else printf("You are using a BIG endian machine!\n");
}
