//============================================================================
// tridisp.cpp : TriModel OPENGL display routines
//============================================================================

// #include <windows.h> // FOR MS-WINDOWS USERS
#include <GL/gl.h>

#include "trimodel.hpp"


void TriModel::Display()
{
  glBegin(GL_TRIANGLES);
  int i;
  for (i=0; i<NumTris; i++)
  {
    glColor3ubv( &((GLubyte*)(&Tris[i].Color))[1] );
    glNormal3fv(&Tris[i].N.x);
    glVertex3fv(&Tris[i].A.x);
    glVertex3fv(&Tris[i].B.x);
    glVertex3fv(&Tris[i].C.x);
  }
  glEnd();
}


void SharedVertTriModel::Display()
{
  glBegin(GL_TRIANGLES);
  int i;
  for (i=0; i<NumTris; i++)
  {
    glColor3ubv( &((GLubyte*)(&Tris[i].Color))[1] );
    glNormal3fv(&Tris[i].N.x);
    glVertex3fv(&Verts[Tris[i].iA].x);
    glVertex3fv(&Verts[Tris[i].iB].x);
    glVertex3fv(&Verts[Tris[i].iC].x);
  }
  glEnd();
}


void SharedVertNormTriModel::Display()
{
  glBegin(GL_TRIANGLES);
  int i;
  for (i=0; i<NumTris; i++)
  {
    glColor3ubv( &((GLubyte*)(&Tris[i].Color))[1] );
    glNormal3fv(&Verts[Tris[i].iA].N.x);
    glVertex3fv(&Verts[Tris[i].iA].V.x);
    glNormal3fv(&Verts[Tris[i].iB].N.x);
    glVertex3fv(&Verts[Tris[i].iB].V.x);
    glNormal3fv(&Verts[Tris[i].iC].N.x);
    glVertex3fv(&Verts[Tris[i].iC].V.x);
  }
  glEnd();
}


